close all;
clear all;
clc;

fs = 44100; %sampling frequency

%time constant for integrating LP filters
tau = 0.1;

%get cutoff frequency
f_cut = 1/(2*pi*tau);

%strings for generating C code of filter coeficients
s_coefs = '';                              
s_coefs = [s_coefs 'const float avrg_filt_coefs[30][3] = {'];

for i = 1:8
    fs = fs/2;
end

%generate coefs and plot characteristics
for i = 1:9
    [b, a] = butter(1,f_cut/(fs/2))
    s_coefs = [s_coefs '{'];
    s_coefs = [s_coefs sprintf('%0.10f, ', b(1))];
    s_coefs = [s_coefs sprintf('%0.10f, ', b(2))];
    if(i < 9)
        s_coefs = [s_coefs sprintf('%0.10f},  //fs = %0.0f Hz\n', -1*a(2), fs)];
        s_coefs = [s_coefs '                                      '];
    else
        s_coefs = [s_coefs sprintf('%0.10f}};  //fs = %0.0f Hz\n', -1*a(2), fs)];
        s_coefs = [s_coefs '                                      '];
    end
    fs = fs*2;
    figure(i)
    freqz(b, a)
end

fileID = fopen('ASA_filt_coefs.c','at');
fprintf(fileID, '\n%s\n\n', s_coefs);
fclose(fileID);
