clc
clear all
close all

%sample, stop and pass band frequencies
fs = 44100;

Wp_Hz = 7200;
Ws_Hz = 15000;

Wp = Wp_Hz/(fs/2);
Ws = Ws_Hz/(fs/2);
Rp = 1;
Rs = 60;

[n,Ws] = cheb2ord(Wp,Ws,Rp,Rs)
[b,a] = cheby2(n,Rs,Ws)

[sos,g] = tf2sos(b,a)

%strings for generating C code of filter coeficients and gains
s_coefs = '';
s_gains = '';
                                                                
s_coefs = [s_coefs 'const float decimation_filt_coefs[15] = {'];
s_gains = [s_gains 'const float decimation_filt_gain = ' sprintf('%0.10f', g) ';'];

%generate coeficients
for j = 1:3
    s_coefs = [s_coefs sprintf('%0.10f, ', sos(j, 1))];
    s_coefs = [s_coefs sprintf('%0.10f, ', sos(j, 2))];
    s_coefs = [s_coefs sprintf('%0.10f, ', sos(j, 3))];
    s_coefs = [s_coefs sprintf('%0.10f, ', -1*sos(j, 5))];
    if(j == 3)
        s_coefs = [s_coefs sprintf('%0.10f};', -1*sos(j, 6))];
    else
        s_coefs = [s_coefs sprintf('%0.10f,\n', -1*sos(j, 6))];
        s_coefs = [s_coefs '                                         '];
    end
end

fileID = fopen('ASA_filt_coefs.c','at');
fprintf(fileID, '\n%s\n\n', s_coefs);
fprintf(fileID, '\n%s\n\n', s_gains);
fclose(fileID);

%plot freq. characteristics
fs = 44100;
for i = 1:8
    figure(i*100)
    freqz(b,a,2000)
    title('Chebyshev Type II Lowpass Filter')
    fs = fs/2;
end